#include<iostream>
using namespace std;
int main () {
	ios_base::sync_with_stdio(false);
	int N, O, A, B, AB, s=0;
	cin>>N>>O>>A>>B>>AB;
	int x[N]; string y[N];
	for (int i=0; i<N; i++) {
		cin>>y[i]>>x[i];
		s+=x[i];	
	}
	if (s>O+A+B+AB) cout<<"nemoguce";
	else {
		int n[N][4]={0};
		bool z=true;
	if (z)	for (int i=0; i<N; i++) {
			if (y[i]=="O") {
				if (x[i]>O) {
				cout<<"nemoguce";
				z=false;
				break;
				
}				else {
					O-=x[i]; n[i][0]=x[i]; 				
} 
}
}
	if (z)	for (int i=0; i<N; i++) {
		
			 if (y[i]=="A") {
					if(x[i]>A+O) {
						cout<<"nemoguce";
						z=false;
						break;
					} 
			 		else if (x[i]>A) {
							 O-=x[i]-A; n[i][1]=A; n[i][0]=x[i]-A; A=0;
			}
						else {
							A-=x[i]; n[i][1]=x[i];
						}
}
}
		if (z)		for (int i=0; i<N; i++) {
				    if (y[i]=="B") {
					     if (x[i]>B+O) {
					     	cout<<"nemoguce";
					     	z=false;
					    	break;
					    
					 }
					 	else if (x[i]>B) {
					 		 O-=x[i]-B; n[i][2]=B; n[i][0]=x[i]-B; B=0;
						 }
						 	 else {
						 	 	B-=x[i]; n[i][2]=x[i];
							  }
				}
			}
		if (z)	for (int i=0; i<N; i++) {
					 if (y[i]=="AB") {
							if (x[i]>A+B+O+AB) {
								cout<<"nemoguce";
								z=false;
								break;
							}
							else if (x[i]>AB) {
								n[i][3]=AB;
								if (B!=0) {
									int g=B;
								B-=x[i]-AB; 
								if (B<0) {
									int o=-B;
								 n[i][2]=g; B=0;
									AB=0;
								if (A!=0) {
									int h=A;
									A-=o;
									if (A<0) {
										int q=-A;
										n[i][1]=h; A=0;
										O-=q; n[i][0]=q;
									}
									else n[i][1]=o;
									
								}
								else {
									O-=o; n[i][0]=o;
								}
								}
								else {
								n[i][2]=x[i]-AB; AB=0;
							}
					}
					else {
						if (A!=0) {
							int f=A;
							A-=x[i]-AB;
							if (A<0) {
								int w=0-A; 
								n[i][1]=f; A=0; AB=0;
								O-=w; n[i][0]=w;
							}
							else {
							n[i][1]=x[i]-AB; AB=0;
						}
						}
						else {
						  O-=AB;	 n[i][0]=x[i]-AB; 
						}
					}		
			}
			else {
				AB-=x[i]; n[i][3]=x[i];
			}
		}
	}
	
	if (z) {
		cout<<"moguce\n";
		for (int i=0; i<N; i++) {
			for (int j=0; j<4; j++) {
				cout<<n[i][j]<<" ";
			}
			cout<<"\n";
		}
	}
	


}
return 0;

}